
package camadaDados;

import classesBasicas.*;
import exceptions.*;
import java.sql.*;
import java.util.ArrayList;

public class RepositorioAlerta {
     private Conexao cnn;
	
	public RepositorioAlerta(Conexao cnn) {
		super();
		this.cnn = cnn;
	}

	public void inserirAlerta(Alerta f) throws AlertaJahExistente {
            boolean bug = false;
            String query ="INSERT INTO SACIAlerta " +
				"(DESCRICAO , DATAINSERIDO , DATAHORADISPARA, LIDO, ID, PLACA ) " +
				"VALUES " +
				"( '" 
					+ f.getDescricao() + "', " 
					+ cnn.stringDataToDate(f.getData_Inserido()) + ", "
					+ cnn.stringDataToDate(f.getData_Inserido()) + ", "
					+ ((f.getLido() ==0)? 0 : 1 )+ ", seq_Alerta.nextval, '"
                                        + f.getPlaca() + "')";
            System.out.println(query);
            try {
                this.cnn.getStmt().execute(query);
            } catch (SQLException ex) {
                ex.printStackTrace();
                bug = true;
            }
            if(bug) throw new AlertaJahExistente();
	}
        /*********************************************
         *** Atualizar Alerta N�o atualiza dastas!!!**
         *********************************************
         */
        public void atualizarAlerta(Alerta f) throws AlertaNaoEncontrado{
            boolean bug = false;
            
            String query ="UPDATE SACIAlerta " +				
				" SET "  
					+ "DESCRICAO = '" + f.getDescricao() + "', " 
					+ "LIDO = " + f.getLido() + ", "
					+ "ID = " + f.getId() + ", "
					+ "PLACA = '" + f.getPlaca() + "'";
            try {
                this.cnn.getStmt().execute(query);
            } catch (SQLException ex) {
                bug = true;
            }
            if(bug) throw new AlertaNaoEncontrado();
        }
        
        public ArrayList<Alerta> buscarAlertas() throws SQLException{
             this.cnn.setRset ( 
			this.cnn.getStmt().executeQuery("SELECT DESCRICAO , TO_CHAR(  DATAINSERIDO , 'DD/MM/YYYY') AS DATAINSERIDO , TO_CHAR(  DATAHORADISPARA , 'DD/MM/YYYY') AS DATAHORADISPARA, LIDO, ID, PLACA " +
			" FROM SACIAlerta")
		);
		
		ArrayList<Alerta> ret = new ArrayList<Alerta>(); 	
		
		while(this.cnn.getRset().next()){
                     ret.add( new Alerta(
                               this.cnn.getRset().getInt("ID"),
                               this.cnn.getRset().getString("PLACA"),
                               this.cnn.getRset().getString("DESCRICAO"),
                               this.cnn.getRset().getString("DATAINSERIDO"),                              
                               this.cnn.getRset().getString("DATAHORADISPARA"),
                               this.cnn.getRset().getInt("LIDO")
                               )
                           );			
		} 
		return ret;
        }
    
    
}
